Pickup = Pickup or {}

function Pickup:construct()

end

function Pickup:FirstUpdate()

	-- Initialising
	self.timer = 5.0
	self.isTouchDown = false
end

function Pickup:Update(dt)

	-- Only run if the game is not paused
	if self.IsGamePaused() then
		return
	end
	
	-- Check the state of the TouchDrag component
	local touchDrag = self:GetSiblingComponentOfType("TouchDrag")
	if touchDrag then
		if touchDrag:IsTouchCaptured() then
			self:OnTouchDown()
			return
		else
			self:OnTouchRelease()
		end	
	end
	
	-- count down the timer
	if self.timer > 0.0 then
		self.timer = self.timer - self.GetGameWorkDt()
		return
	end
	
	-- once timer is up, start disappearing
	self:OnDisapper()
end

function Pickup:OnTouchDown()
	if self.isTouchDown then
		return
	end
	
	local screenEscaper = self:GetSiblingComponentOfType("Animator_ScreenEscaper")
	if screenEscaper then
		screenEscaper:Disable()
	end
	
	local screenWander = self:GetSiblingComponentOfType("Animator_ScreenWander")
	if screenWander then
		screenWander:Disable()
	end
	
	local pusher = self:GetSiblingComponentOfType("Animator_Pusher")
	if pusher then
		pusher:Disable()
	end
	
	local collectableComponent = self:GetSiblingComponentOfType("CollectableComponent")
	if collectableComponent then
		collectableComponent:SetCanBeCollected(true)
	else
		PrintString("CollectableComponent is nil!")
	end
	
	self.isTouchDown = true
	self.timer = 5.0
end

function Pickup:OnTouchRelease()
	if not self.isTouchDown then
		return
	end
	
	local screenWander = self:GetSiblingComponentOfType("Animator_ScreenWander")
	if screenWander then
		screenWander:Enable()
	end
	
	local pusher = self:GetSiblingComponentOfType("Animator_Pusher")
	if pusher then
		pusher:Enable()
	end
	
	local collectableComponent = self:GetSiblingComponentOfType("CollectableComponent")
	if collectableComponent then
		collectableComponent:SetCanBeCollected(false)
	else
		PrintString("CollectableComponent is nil!")
	end
	
	self.isTouchDown = false
end

function Pickup:OnDisapper()
	
	local screenEscaper = self:GetSiblingComponentOfType("Animator_ScreenEscaper")
	if screenEscaper then
		screenEscaper:Enable()
	end
	
	local screenWander = self:GetSiblingComponentOfType("Animator_ScreenWander")
	if screenWander then
		screenWander:Disable()
	end
end
